;; $Id: dbfootn.dsl 0.1 1997/07/31 14:51:33 nwalsh Exp $

(element FOOTNOTE ;; A footnote inserts a reference to itself
  (let ((id (if (attribute-string "ID")
		(attribute-string "ID")
		(generate-xptr))))
    (make element gi: "A"
	  attributes: (list
		       (list "NAME" id)
		       (list "HREF" (string-append "#FTN." id)))
	  (literal 
	   (string-append 
	    "[" ($footnote-number$ (current-node)) "]")))))
      

(element FOOTNOTEREF
  (let* ((target (element-with-id (attribute-string "LINKEND")))
	 (id (if (attribute-string "ID" target)
		 (attribute-string "ID" target)
		 (generate-xptr target))))
    (make element gi: "A"
	  attributes: (list
		       (list "HREF" (href-to target)))
	  (literal 
	   (string-append
	    "[" ($footnote-number$ target) "] ")))))


(define ($chunk-footnote-number$ footnote)
  (let* ((chunk (chunk-level-parent footnote))
	 (footnotes (select-elements (descendants chunk) "FOOTNOTE")))
    (let loop ((nl footnotes) (num 1))
      (if (node-list-empty? nl)
	  0
	  (if (node-list=? footnote (node-list-first nl))
	      num
	      (loop (node-list-rest nl)
		    (+ num 1)))))))

(define ($table-footnote-number$ footnote)
  (let* ((chunk (ancestor "TGROUP" footnote))
	 (footnotes (select-elements (descendants chunk) "FOOTNOTE")))
    (let loop ((nl footnotes) (num 1))
      (if (node-list-empty? nl)
	  0
	  (if (node-list=? footnote (node-list-first nl))
	      num
	      (loop (node-list-rest nl)
		    (+ num 1)))))))

(define ($footnote-number$ footnote)
  (if (node-list-empty? (ancestor "TGROUP" footnote))
      (format-number ($chunk-footnote-number$ footnote) "1")
      (format-number ($table-footnote-number$ footnote) "a")))

(mode footnote-mode
  (element FOOTNOTE
    (process-children))

  (element (FOOTNOTE PARA)
    (let ((id (if (attribute-string "ID" (parent (current-node)))
		  (attribute-string "ID" (parent (current-node)))
		  (generate-xptr (parent (current-node))))))
      (make element gi: "P"
	    (if (= (child-number) 1)
		(make element gi: "A"
		      attributes: (list
				   (list "NAME" (string-append "FTN." id))
				   (list "HREF" (href-to (parent (current-node)))))
		      (literal 
		       (string-append
			"[" ($footnote-number$ (parent (current-node))) "] ")))
		      (literal ""))
	    (process-children))))
)
